*   PROGRAM:  MAINMENU.PRG
*   AUTHOR:   Alan D. Frazier
*   DATE:     03.19.92
*   LANGUAGE: Dbase-IV 1.1 x509, DOS, Unix, or MAC version.
*   REQUIRES: Color Monitor

* ͻ
*  MANY-TO-MANY RELATIONSHIP DEMONSTRATION - MENU DRIVER               
* ͼ


SET STATUS OFF
SET SCOREBOARD OFF
SET CONFIRM ON
SET TALK OFF
SET ECHO OFF
DO D_menu1
Answer = " "
SET DELETED ON
ACTIVATE POPUP Menu_01
CLOSE DATABASES
SET STATUS ON
SET SCOREBOARD ON
SET CONFIRM OFF
SET TALK ON
RETURN



*  Ŀ
*    PROCEDURES (procedures are used throughout the system)     
*  

* Ŀ
*     PROCEDURE TO DEFINE ACTION TAKEN FROM MAIN MENU POPUP   
* 

PROCEDURE Act_1
PARAMETERS bar
gn_barv = bar
DO BANNER

DO CASE
   CASE gn_barv = 2
        DO SAMPLE
        DO BANNER
   CASE gn_barv = 4
        DO ADD_NAME
        DO BANNER
   CASE gn_barv = 5
        DO ADD_SKIL
        DO BANNER
   CASE gn_barv = 6
        DO DEL_NAME
        DO BANNER
   CASE gn_barv = 7
        DO DEL_SKIL
        DO BANNER
   CASE gn_barv = 9
        RUN PCMAGHLP
        DO BANNER
   CASE gn_barv = 10
        DEACTIVATE POPUP
        CLOSE DATABASES
        SET STATUS ON
        SET SCOREBOARD ON
        SET CONFIRM OFF
        SET TALK ON
        SET ECHO ON
        RETURN
ENDCASE
RETURN


* Ŀ
*   PROCEDURE TO DEFINE MAIN MENU POPUP          
* 

PROCEDURE D_menu1
    DO BANNER
    SET BORDER TO DOUBLE
    DEFINE POPUP Menu_01 FROM 6,20
    DEFINE BAR 2  OF Menu_01 PROMPT " DISPLAY SAMPLE RELATIONSHIPS";
           MESSAGE "Build Many-To-Many relationship, and display records"
    DEFINE BAR 4  OF Menu_01 PROMPT " ADD NEW NAME";
           MESSAGE "Add new Name and build Skills"
    DEFINE BAR 5  OF Menu_01 PROMPT " ADD NEW SKILL";
           MESSAGE "Add new Skill and link to related Names"
    DEFINE BAR 6  OF Menu_01 PROMPT " DELETE NAME";
           MESSAGE "Delete a given Name and all related links to Skills"
    DEFINE BAR 7  OF Menu_01 PROMPT " DELETE SKILL";
           MESSAGE "Delete a given Skill and all links to related Names"
    DEFINE BAR 9  OF Menu_01 PROMPT " Access On-Line Help";
           MESSAGE "View the On-Help and documentation information"
    DEFINE BAR 10 OF Menu_01 PROMPT " Exit From This Menu  ";
           MESSAGE "Exit System"
    ON SELECTION POPUP Menu_01 DO Act_1 WITH BAR()
RETURN


* Ŀ
*   PROCEDURE TO DISPLAY BANNER                  
* 

PROCEDURE BANNER

    SET COLOR OF NORMAL TO RG+/B
    @ 2,5 TO 4,75 DOUBLE
    @ 3,10 SAY "MAIN MENU FOR DEMONSTRATION OF MANY-TO-MANY RELATIONSHIPS"
    SET COLOR OF NORMAL TO W+/B
    RETURN


*  ͻ
*       PICK LIST PROCEDURE                                               
*  ͼ
*  Ŀ
*  PICKLIST use syntax:                                                   
*                                                                         
*   DO PickList WITH "<Prompt string>", <Top>, <Left>, <Bottom>, <Right>, 
*                   <Normal text color>, <Highlight color>, <Border type> 
*                                                                         
*    SAMPLE:                                                              
*                                                                         
*    DO PICKLIST WITH "field_1,Field_2",6,1,20,40,G/B,R/B,DOUBLE          
*                                                                         
*  

PROCEDURE Picklist
PARAMETER mFields, mTop, mLeft, mBott, mRight, mNormcolor, mFieldcolor, mBorder

mCursor = SET("CURSOR")
mEscape = SET("ESCAPE")
mTalk   = SET("TALK")
SET CURSOR OFF
SET ESCAPE OFF
SET TALK OFF
mTypeCheck = TYPE("mFields")+TYPE("mTop")+TYPE("mLeft")+TYPE("mBott")+ ;
    TYPE("mRight")+TYPE("mNormColor")+TYPE("mFieldcolor")+TYPE("mBorder")

mError = .F.
DO CASE
    && Check data types
    CASE mTypeCheck # "CNNNNCCC"
        CLEAR
        @ 7,17 SAY "Data type mismatch -- check all parameters"
        mError = .T.
        
    && Check for bottom limit with STATUS ON
    CASE ((mBott >21 .AND. SET("DISPLAY") # "EGA43")    ;
        .OR. (mBott >39 .AND. SET("DISPLAY") = "EGA43")) ;
        .AND. SET("STATUS") = "ON"
        CLEAR
        @ 7,15 SAY "Cannot use this popup on or below STATUS line"
        mError = .T.
        
    && Check for bottom limit with STATUS OFF
    CASE ((mBott >24 .AND. SET("DISPLAY") # "EGA43")    ;
        .OR. (mBott >42 .AND. SET("DISPLAY") = "EGA43")) ;
        .AND. SET("STATUS") = "OFF"
        CLEAR
        @ 7,16 SAY "Bottom coordinate beyond bottom of screen"
        mError = .T.
        
    && Check left & right coordinates
    CASE mLeft < 0 .OR. mRight > 79
        CLEAR
        @ 7,24 SAY "Invalid Column coordinate"
        mError = .T.
    
    && Check to make sure popup can display at least one record
    CASE mBott - mTop < 2
        CLEAR
        @ 7,19 SAY "Popup must be at least 3 lines high"
        mError = .T.
        
ENDCASE

IF mError
    @ 5,5 TO 9,70 DOUBLE
    @ 11, 32 SAY "Press Any Key"
    mX = 0
    DO WHILE mX = 0
        mX = INKEY()
    ENDDO
    SET CURSOR &mCursor
    SET ESCAPE &mEscape
    SET TALK &mTalk
    RETURN
ENDIF

&& Save colors of NORMAL and FIELDS to restor when done
mFieldSet = SET("ATTRIBUTES")
mNormSet = LEFT(mFieldSet, AT(",",mFieldSet)-1)
DO WHILE "," $ mFieldSet
    mFieldSet = SUBSTR(mFieldSet, AT(",",mFieldSet)+1)
ENDDO

&& If they were provided, set to colors passed on from calling program
IF LEN(mNormcolor) # 0
    SET COLOR OF NORMAL TO &mNormcolor
ENDIF
IF LEN(mFieldcolor) # 0
    SET COLOR OF FIELDS TO &mFieldcolor
ENDIF

mPromptW = mRight - mLeft - 1
@ mTop, mLeft CLEAR TO mBott, mRight 
@ mTop, mLeft TO mBott, mRight &mBorder

IF EOF()
   SKIP -1
ENDIF

&& Save current record pointer and determine record number of top record
mTmpRec = RECNO()
GO TOP
mToprec = RECNO()
GO mTmpRec
mMaxRecs = mBott - mTop - 1
mKey = 0
mGoBack = .F.
DECLARE mPrompt[mMaxRecs], mRec[mMaxRecs]

DO WHILE .NOT. mGoBack
    mChcnum = 1
    mToprow = mTop + 1
    mLeftcol = mLeft + 1
    mRowoffset = 0
    mLastcurs = 0

    && This loop puts text into prompts
    DO WHILE mRowoffset + 1 <= mMaxRecs
        IF .NOT. EOF()
            mTemp = &mFields             && Expands mFields into string expression
            mPrompt[mChcnum] = SUBSTR(mTemp, 1, mPromptW)
            
            && If prompt doesn't fill entire box, add spaces
            IF LEN(mPrompt[mChcnum]) < mPromptW
                mPrompt[mChcnum] = mPrompt[mChcnum] + ;
                SPACE(mPromptW - LEN(mPrompt[mChcnum]))
            ENDIF

            mRec[mChcnum] = RECNO()
            @ mToprow+mRowoffset , mLeftcol SAY mPrompt[mChcnum]
        ENDIF
        mRowoffset = mRowoffset + 1
        mChcnum = mChcnum + 1
        SKIP
        
        && If last record reached, clear rest of box
        IF EOF()
            DO WHILE mRowoffset + 1 <= mMaxRecs
                @ mToprow+mRowoffset, mLeftcol SAY SPACE(mPromptW)
                mRowoffset = mRowoffset +1
            ENDDO
            EXIT
        ENDIF
    ENDDO
    
    mHighchc = mChcnum - 1
    IF mKey # 2 .AND. mKey # 3   && if the last key pressed wasn't <END>
        mChcnum = 1               && or <PgDn>
        mRowoffset = 0
    ELSE
        mChcnum = mHighchc
        mRowoffset = mHighchc - 1
    ENDIF
    
    @ mToprow+mRowoffset , mLeftcol GET mPrompt[mChcnum]
    CLEAR GETS
    
    && This loops traps the keys
    DO WHILE .T.
        mKey = INKEY()
        DO CASE
        
            CASE mKey = 5   && Up arrow
                
                && If first record displayed is first record in database
                && and it is already highlighted
                IF mRec[1] = mToprec .AND. mChcnum = 1
                    LOOP
                ENDIF
                
                && If first record is highlighted but is not top record,
                && shift prompt contents down
                IF mRec[1] # mToprec .AND. mChcnum = 1
                    GO mRec[1]
                    mX = mHighchc 
                    DO WHILE mX > 1
                        mRec[mX] = mRec[mX - 1]
                        mPrompt[mX] = mPrompt[mX - 1]
                        mX = mX - 1
                    ENDDO
                    
                    && Get prompt for additional record to be displayed
                    SKIP -1
                    mRec[1] = RECNO()
                    mTemp = &mFields
                    mPrompt[1] = SUBSTR(mTemp, 1, mPromptW)
                    IF LEN(mPrompt[1]) < mPromptW
                        mPrompt[1] = mPrompt[1] + ;
                        SPACE(mPromptW - LEN(mPrompt[1]))
                    ENDIF
                    SKIP + mMaxrecs
                    
                    && If maximum possible records aren't displayed
                    IF mHighchc < mMaxrecs
                        mHighchc = mHighchc + 1
                        SKIP -1
                        mRec[mHighchc] = RECNO()
                        mTemp = &mFields
                        mPrompt[mHighchc] = SUBSTR(mTemp, 1, mPromptW)
                        IF LEN(mPrompt[mHighchc]) < mPromptW
                            mPrompt[mHighchc] = mPrompt[mHighchc] + ;
                            SPACE(mPromptW - LEN(mPrompt[mHighchc]))
                        ENDIF
                        SKIP
                    ENDIF
                    
                    && Redisplay prompts with new contents
                    mX = 1
                    DO WHILE mX < mHighchc + 1
                        @ mToprow + mX - 1, mLeftcol SAY mPrompt[mX]
                        mX = mX + 1
                    ENDDO
                    mChcnum = 2
                ENDIF
                
               mChcnum = IIF(mChcnum = 1, mHighchc, mChcnum - 1)
               mRowoffset = IIF(mChcnum = 1, 0, mChcnum - 1)
               mLastone = IIF(mChcnum = mHighchc, 1, mChcnum+1)
               mThisone = mChcnum

               @ mToprow+IIF(mChcnum = mHighchc, 0, mRowoffset+1) , ;
                  mLeftcol SAY mPrompt[mLastone]
               @ mToprow+mRowoffset , mLeftcol GET mPrompt[mThisone]
               CLEAR GETS

            CASE mKey = 24   && Dn arrow
                
                && If last prompt is highlighted and it is last record
                IF EOF() .AND. mChcnum = mHighchc
                    LOOP
                ENDIF
                
                && If not at last record and bottom prompt is highlighted,
                && shift prompt contents up
                IF .NOT. EOF() .AND. mChcnum = mHighchc
                    mX = 1
                    DO WHILE mX < mMaxrecs
                        mRec[mX] = mRec[mX + 1]
                        mPrompt[mX] = mPrompt[mX + 1]
                        mX = mX + 1
                    ENDDO
                    
                    && Get prompt for additional record to be displayed
                    mRec[mMaxrecs] = RECNO()
                    mTemp = &mFields
                    mPrompt[mMaxrecs] = SUBSTR(mTemp, 1, mPromptW)
                    IF LEN(mPrompt[mMaxrecs]) < mPromptW
                        mPrompt[mMaxrecs] = mPrompt[mMaxrecs] + ;
                        SPACE(mPromptW - LEN(mPrompt[mMaxrecs]))
                    ENDIF
                    SKIP
                    
                    && Redisplay prompts with new contents
                    mX = mMaxrecs
                    DO WHILE mX > 0
                        @ mToprow + mX - 1, mLeftcol SAY mPrompt[mX]
                        mX = mX - 1
                    ENDDO
                    mChcnum = mMaxrecs - 1
                ENDIF
                
               mChcnum = IIF(mChcnum < mHighchc, mChcnum + 1, 1)
               mRowoffset = IIF(mChcnum = 1, 0, mChcnum - 1)
               mLastone = IIF(mChcnum = 1, mHighchc, mChcnum-1)
               mThisone = mChcnum

               @ mToprow+IIF(mChcnum = 1, mHighchc-1, mRowoffset-1) , ;
                  mLeftcol SAY mPrompt[mLastone]
               @ mToprow+mRowoffset , mLeftcol GET mPrompt[mThisone]
               CLEAR GETS

            CASE mKey = 13   && Enter key
                && Move record pointer and go back to calling program
                GO mRec[mChcnum]
                mGoback = .T.
                EXIT

            CASE mKey = 3    && PgDn key
                
                && If last record in .DBF is displayed but not highlighted,
                && move highlight to bottom and wait for next key 
                IF EOF() .AND. mChcnum # mHighchc
                    @ mToprow + mRowoffset, mLeftcol SAY mPrompt[mChcnum]
                    @ mToprow + mHighchc - 1, mLeftcol GET mPrompt[mHighchc]
                    CLEAR GETS
                    mChcnum = mHighchc
                    mRowoffset = mChcnum - 1
                    LOOP
                ENDIF
                
                && If highlight is not on last record that is displayed,
                && move highlight to it and wait for next key
                IF mChcnum # mHighchc
                    @ mToprow + mRowoffset, mLeftcol SAY mPrompt[mChcnum]
                    @ mToprow + mHighchc - 1, mLeftcol GET mPrompt[mHighchc]
                    CLEAR GETS
                    mChcnum = mHighchc
                    mRowoffset = mChcnum - 1
                    LOOP
                ENDIF
                
                && Highlight is at bottom record displayed but not at EOF
                && Move record pointer down to next "page" of records and
                && return to main loop
                IF .NOT. EOF()
                    GO mRec[1]
                    SKIP + mMaxRecs
                    mGoback = .F.
                    EXIT
                ENDIF
                
                && If none of the above is true, wait for another key
                LOOP

            CASE mKey = 18    && PgUp key
                
                && If top record displayed is top of .DBF but it is
                && not highlighted, move highlight to it and wait for next key
                IF mRec[1] = mToprec .AND. mChcnum # 1
                    @ mToprow + mRowoffset, mLeftcol SAY mPrompt[mChcnum]
                    @ mToprow, mLeftcol GET mPrompt[1]
                    CLEAR GETS
                    mChcnum = 1
                    mRowoffset = 0
                    LOOP
                ENDIF
                
                && If highlight is not on top record displayed, move 
                && highlight to it and wait for next key
                IF mChcnum # 1
                    @ mToprow + mRowoffset, mLeftcol SAY mPrompt[mChcnum]
                    @ mToprow, mLeftcol GET mPrompt[1]
                    CLEAR GETS
                    mChcnum = 1
                    mRowoffset = 0
                    LOOP
                ENDIF
                
                && Highlight is at top record displayed but not at top of DBF.
                && Move record pointer up one "page" worth of records and 
                && return to main loop to display new prompts
                IF mRec[1] # mToprec
                    GO mRec[1]
                    SKIP - mMaxRecs
                    mGoback = .F.
                    EXIT
                ENDIF
                
                && If none of the above is true, wait for next key
                LOOP
                
            CASE mKey = 27   && Esc key
                && Move record pointer to where it was before starting this
                && routine and return to calling program
                mAbandon = .T.
                mGoback = .T.
                GO mTmpRec
                EXIT

            CASE mKey = 26    && Home key
                
                && If already at top of DBF, wait for next key
                IF mRec[1] = mTopRec
                LOOP
             ELSE && go top and return to main loop to display new prompts
                    GO TOP
                    mGoback = .F.
                    EXIT
                ENDIF

            CASE mKey = 2    && End key
            
                && If last record in DBF is displayed but not highlighted,
                && move highlight to it and wait for next key
                IF EOF() .AND. mChcnum # mHighchc
                    @ mToprow + mRowoffset, mLeftcol SAY mPrompt[mChcnum]
                    @ mToprow + mHighchc - 1, mLeftcol GET mPrompt[mHighchc]
                    CLEAR GETS
                    mChcnum = mHighchc
                    mRowoffset = mChcnum - 1
                   LOOP
                ENDIF
                
                && If last record is not displayed, go to it and 
                && return to main loop
                IF .NOT. EOF()
                    GO BOTTOM
                    SKIP - (mMaxrecs - 1)
                    mGoback = .F.
                    EXIT
                ENDIF
                
                && If none of the above is true, go back and wait for next key
                LOOP

            CASE mKey = 28  && F1 key
            && This is just sample code for the F1 key
                DEFINE WINDOW TempWin FROM 5,4 TO 14,75
                ACTIVATE WINDOW TempWin
                @ 1,3 SAY "Use cursor keys to choose. Press <Enter> to move record pointer"
                @ 2,5 SAY "Use <PgUp>, <PgDn>, <Home>, and <End> to see other records"
                @ 3,26 SAY "Use <Esc> to abandon"
                @ 5,23 SAY "Press Any Key to Continue"
                mX = 0
                DO WHILE mX = 0
                    mX = INKEY()
                ENDDO
                DEACTIVATE WINDOW TempWin
            
            CASE mKey = -1  && F2 key
            && This is just sample code for the F2 key
                SAVE SCREEN TO mScreen
                mX = RECNO()
                GO mRec[mChcnum]
                SET CURSOR ON
                EDIT NOMENU NOAPPEND NODELETE NEXT 1
                * READ is better if you already have a FORMAT set.
                SET CURSOR OFF
                GO mRec[mChcnum]
                mTemp = &mFields             && Expands mFields into string expression
                mPrompt[mChcnum] = SUBSTR(mTemp, 1, mPromptW)
                IF LEN(mPrompt[mChcnum]) < mPromptW
                    mPrompt[mChcnum] = mPrompt[mChcnum] + ;
                    SPACE(mPromptW - LEN(mPrompt[mChcnum]))
                ENDIF
                RESTORE SCREEN FROM mScreen
                @ mToprow+mRowoffset, mLeftcol GET mPrompt[mChcnum]
                CLEAR GETS
                IF mX <= RECCOUNT()
                    GO mX
                ELSE
                    GO BOTT
                    SKIP
                ENDIF
        ENDCASE
    ENDDO
ENDDO

&& Put colors back to what they were and set CURSOR, ESCAPE, and TALK back
SET COLOR OF NORMAL TO &mNormSet
SET COLOR OF FIELDS TO &mFieldSet
SET CURSOR &mCursor
SET ESCAPE &mEscape
SET TALK &mTalk
RETURN

*  Ŀ
*        END OF PICKLIST PROCEDURE                                
*  


* Ŀ
*   End of Program   Ĵ
* 

